using System.Web.Mvc;
using System.Configuration;
namespace SelectPdf.Samples.Controllers
{
    public class AdvancedPdfSecurityController : Controller
    {
        // GET: AdvancedPdfSecurity
        public ActionResult Index()
        {
            return View();
        }
        [HttpPost]
        public ActionResult SubmitAction(FormCollection collection)
        {

            // the initial file
            string file = Server.MapPath("~/files/doc1.pdf");

            // the certificate
            string certFile = Server.MapPath("~/files/selectpdf.pfx");

            // load the pdf document using the advanced security manager
            PdfSecurityManager security = new PdfSecurityManager();
            security.Load(file);

            // encryption algorithm and key length
            security.EncryptionAlgorithm = PdfEncryptionAlgorithm.AES;
            security.EncryptionKeySize = PdfEncryptionKeySize.EncryptKey256Bit;

            // set document passwords
            security.OwnerPassword = "test1";
            security.UserPassword = "test2";

            //set document permissions
            security.CanAssembleDocument = false;
            security.CanCopyContent = true;
            security.CanEditAnnotations = true;
            security.CanEditContent = true;
            security.CanFillFields = true;
            security.CanPrint = true;

            // add the digital signature
            security.Sign(certFile, "selectpdf");

            // save pdf document
            byte[] pdf = security.Save();

            // close pdf document
            security.Close();                                 

            // return resulted pdf document
            FileResult fileResult = new FileContentResult(pdf, "application/pdf");
            fileResult.FileDownloadName = "Document.pdf";
            return fileResult;
        }
    }
}